searchNodes=[{"ref":"Doctor.html","title":"Doctor","type":"module","doc":"Doctor is a utility which aims to provide insights into the health of your project&#39;s documentation. In addition to be a useful development time tool, Doctor can also be useful during CI/CD and can block merges and releases if the documentation coverage is not up to spec. Doctor comes with sane defaults out of the box, but if you wish to customize its settings, feel free to create your own .doctor.exs file."},{"ref":"Doctor.CLI.html","title":"Doctor.CLI","type":"module","doc":"Provides the various CLI task entry points and CLI arg parsing."},{"ref":"Doctor.CLI.html#run_report/1","title":"Doctor.CLI.run_report/1","type":"function","doc":"Given the CLI arguments, run the report on the project,"},{"ref":"Doctor.Config.html","title":"Doctor.Config","type":"module","doc":"This module defines a struct which houses all the configuration data for Doctor."},{"ref":"Doctor.Config.html#config_defaults_as_map/0","title":"Doctor.Config.config_defaults_as_map/0","type":"function","doc":"Get the configuration defaults as a Config struct"},{"ref":"Doctor.Config.html#config_defaults_as_string/0","title":"Doctor.Config.config_defaults_as_string/0","type":"function","doc":"Get the configuration defaults as a string"},{"ref":"Doctor.Config.html#config_file/0","title":"Doctor.Config.config_file/0","type":"function","doc":"Get the configuration file name"},{"ref":"Doctor.Docs.html","title":"Doctor.Docs","type":"module","doc":"This module defines a struct which houses all the documentation data for module functions."},{"ref":"Doctor.Docs.html#build/1","title":"Doctor.Docs.build/1","type":"function","doc":"Build the Docs struct from the results of Code.fetch_docs/0"},{"ref":"Doctor.ModuleInformation.html","title":"Doctor.ModuleInformation","type":"module","doc":"This module defines a struct which houses all the documentation data for an entire module."},{"ref":"Doctor.ModuleInformation.html#build/2","title":"Doctor.ModuleInformation.build/2","type":"function","doc":"Breaks down the docs format entry returned from Code.fetch_docs(MODULE)"},{"ref":"Doctor.ModuleInformation.html#load_file_ast/1","title":"Doctor.ModuleInformation.load_file_ast/1","type":"function","doc":"Given the provided module, read the file from which the module was generated and convert the file to an AST."},{"ref":"Doctor.ModuleInformation.html#load_user_defined_functions/1","title":"Doctor.ModuleInformation.load_user_defined_functions/1","type":"function","doc":"Given a ModuleInformation struct with the AST loaded, fetch all of the author defined functions"},{"ref":"Doctor.ModuleReport.html","title":"Doctor.ModuleReport","type":"module","doc":"This module exposes a struct which encapsulates all the results for a doctor report. Whether the module has a moduledoc, what the doc coverage is, the number of author defined functions, and so on."},{"ref":"Doctor.ModuleReport.html#build/1","title":"Doctor.ModuleReport.build/1","type":"function","doc":"Given a ModuleInformation struct with the necessary fields completed, build the report."},{"ref":"Doctor.ReportUtils.html","title":"Doctor.ReportUtils","type":"module","doc":"This module provides some utility functions for use in report generators."},{"ref":"Doctor.ReportUtils.html#calc_overall_doc_coverage/1","title":"Doctor.ReportUtils.calc_overall_doc_coverage/1","type":"function","doc":"Calculate the overal doc coverage in the codebase"},{"ref":"Doctor.ReportUtils.html#calc_overall_spec_coverage/1","title":"Doctor.ReportUtils.calc_overall_spec_coverage/1","type":"function","doc":"Calculate the overal spec coverage in the codebase"},{"ref":"Doctor.ReportUtils.html#count_total_documented_functions/1","title":"Doctor.ReportUtils.count_total_documented_functions/1","type":"function","doc":"Given a list of module reports, count the total number of documented functions"},{"ref":"Doctor.ReportUtils.html#count_total_failed_modules/2","title":"Doctor.ReportUtils.count_total_failed_modules/2","type":"function","doc":"Given a list of module reports, count the total number of failed modules"},{"ref":"Doctor.ReportUtils.html#count_total_functions/1","title":"Doctor.ReportUtils.count_total_functions/1","type":"function","doc":"Given a list of module reports, count the total number of functions"},{"ref":"Doctor.ReportUtils.html#count_total_passed_modules/2","title":"Doctor.ReportUtils.count_total_passed_modules/2","type":"function","doc":"Given a list of module reports, count the total number of passed modules"},{"ref":"Doctor.ReportUtils.html#count_total_speced_functions/1","title":"Doctor.ReportUtils.count_total_speced_functions/1","type":"function","doc":"Given a list of module reports, count the total number of speced functions"},{"ref":"Doctor.ReportUtils.html#doctor_report_passed?/2","title":"Doctor.ReportUtils.doctor_report_passed?/2","type":"function","doc":"Check whether Doctor overall has passed or failed validation"},{"ref":"Doctor.ReportUtils.html#module_passed_validation?/2","title":"Doctor.ReportUtils.module_passed_validation?/2","type":"function","doc":"Checks whether the provided module passed validation"},{"ref":"Doctor.Reporter.html","title":"Doctor.Reporter","type":"behaviour","doc":"Defines the behaviour for a reporter"},{"ref":"Doctor.Reporter.html#c:generate_report/2","title":"Doctor.Reporter.generate_report/2","type":"callback","doc":""},{"ref":"Doctor.Reporter.html#t:module_reports/0","title":"Doctor.Reporter.module_reports/0","type":"type","doc":""},{"ref":"Doctor.Reporters.Full.html","title":"Doctor.Reporters.Full","type":"module","doc":"This reporter generates a full documentation coverage report and lists all the files in the project along with whether they pass or fail."},{"ref":"Doctor.Reporters.Full.html#generate_report/2","title":"Doctor.Reporters.Full.generate_report/2","type":"function","doc":"Generate a full Doctor report and print to STDOUT"},{"ref":"Doctor.Reporters.OutputUtils.html","title":"Doctor.Reporters.OutputUtils","type":"module","doc":"This module provides convenience functions for use when generating reports"},{"ref":"Doctor.Reporters.OutputUtils.html#generate_table_line/1","title":"Doctor.Reporters.OutputUtils.generate_table_line/1","type":"function","doc":"Generate a line in a table with the given width and padding. Expects a list with either a 2 or 3 element tuple."},{"ref":"Doctor.Reporters.Short.html","title":"Doctor.Reporters.Short","type":"module","doc":"This reporter generates a full documentation coverage report and lists all the files in the project along with whether they pass or fail."},{"ref":"Doctor.Reporters.Short.html#generate_report/2","title":"Doctor.Reporters.Short.generate_report/2","type":"function","doc":"Generate a full Doctor report and print to STDOUT"},{"ref":"Doctor.Reporters.Summary.html","title":"Doctor.Reporters.Summary","type":"module","doc":"This reporter generates a short summary documentation coverage report and lists overall how many modules passed/failed."},{"ref":"Doctor.Reporters.Summary.html#generate_report/2","title":"Doctor.Reporters.Summary.generate_report/2","type":"function","doc":"Generate a short summary Doctor report and print to STDOUT"},{"ref":"Doctor.Specs.html","title":"Doctor.Specs","type":"module","doc":"This module defines a struct which houses all the documentation data for function specs."},{"ref":"Doctor.Specs.html#build/1","title":"Doctor.Specs.build/1","type":"function","doc":"Build a spec definition for each result from Code.Typespec.fetch_specs/1"},{"ref":"readme.html","title":"Doctor","type":"extras","doc":"Doctor Ensure that your documentation is healthy with Doctor! This library contains a mix task which you can run against your project to generate a documentation coverage report. Items which are reported on include: the presence of module docs, which functions do/don&#39;t have docs, and which functions do/don&#39;t have typespecs. You can generate a .doctor.exs config file to specify what thresholds are acceptable for your project. If documentation coverage drops below your specified thresholds, the mix doctor task will return a non zero exit status. The primary motivation with this tool is to have something simple which can be hooked up into CI to ensure that project documentation standards are respected and upheld."},{"ref":"readme.html#installation","title":"Doctor - Installation","type":"extras","doc":"Available in Hex, the package can be installed by adding doctor to your list of dependencies in mix.exs: def deps do [ {:doctor, &quot;~&gt; 0.7.0&quot;} ] end Documentation can be found at https://hexdocs.pm/doctor."},{"ref":"readme.html#usage","title":"Doctor - Usage","type":"extras","doc":"Doctor comes with 2 mix tasks. One to run the documentation coverage report, and another to generate a .doctor.exs config file. To run the doctor mix task and generate a report run: mix doctor To generate a .doctor.exs config file with defaults, run: mix doctor.gen.config"},{"ref":"readme.html#sample-report","title":"Doctor - Sample report","type":"extras","doc":"Report created for Doctor itself: Doctor file found. Loading configuration. -------------------------------------------------------------------------------------------------------------------------------------------------------------------------- DOC COV SPEC COV MODULE FILE FUNCTIONS NO DOCS NO SPECS MODULE DOC 100% 0% Doctor.CLI lib/cli/cli.ex 1 0 1 YES 100% 0% Doctor.Config lib/config.ex 3 0 3 YES 100% 0% Doctor.Docs lib/docs.ex 1 0 1 YES NA NA Doctor lib/doctor.ex 0 0 0 YES 100% 0% Mix.Tasks.Doctor lib/mix/tasks/doctor.ex 1 0 1 YES 100% 0% Mix.Tasks.Doctor.Gen.Config lib/mix/tasks/doctor.gen.config.ex 1 0 1 YES 100% 0% Doctor.ModuleInformation lib/module_information.ex 3 0 3 YES 100% 0% Doctor.ModuleReport lib/module_report.ex 1 0 1 YES 100% 0% Doctor.ReportUtils lib/report_utils.ex 9 0 9 YES NA NA Doctor.Reporter lib/reporter.ex 0 0 0 YES 100% 0% Doctor.Reporters.Full lib/reporters/full.ex 1 0 1 YES 100% 0% Doctor.Reporters.OutputUtils lib/reporters/output_utils.ex 1 0 1 YES 100% 0% Doctor.Reporters.Summary lib/reporters/summary.ex 1 0 1 YES 100% 0% Doctor.Specs lib/specs.ex 1 0 1 YES -------------------------------------------------------------------------------------------------------------------------------------------------------------------------- Summary: Passed Modules: 14 Failed Modules: 0 Total Doc Coverage: 100.0% Total Spec Coverage: 0.0% Doctor validation has passed! Report created for Phoenix: Doctor file not found. Using defaults. -------------------------------------------------------------------------------------------------------------------------------------------------------------------------- Doc Cov Spec Cov Module File Functions No Docs No Specs Module Doc 100% 0% Mix.Phoenix lib/mix/phoenix.ex 18 0 18 YES 0% 0% Mix.Phoenix.Context lib/mix/phoenix/context.ex 6 6 6 YES 63% 0% Mix.Phoenix.Schema lib/mix/phoenix/schema.ex 8 3 8 YES 100% 0% Mix.Tasks.Compile.Phoenix lib/mix/tasks/compile.phoenix.ex 2 0 2 YES 100% 0% Mix.Tasks.Phx.Digest.Clean lib/mix/tasks/phx.digest.clean.ex 1 0 1 YES 100% 0% Mix.Tasks.Phx.Digest lib/mix/tasks/phx.digest.ex 1 0 1 YES 100% 0% Mix.Tasks.Phx lib/mix/tasks/phx.ex 1 0 1 YES 100% 0% Mix.Tasks.Phx.Gen.Cert lib/mix/tasks/phx.gen.cert.ex 2 0 2 YES 100% 0% Mix.Tasks.Phx.Gen.Channel lib/mix/tasks/phx.gen.channel.ex 1 0 1 YES 86% 14% Mix.Tasks.Phx.Gen.Context lib/mix/tasks/phx.gen.context.ex 7 1 6 YES 100% 17% Mix.Tasks.Phx.Gen.Embedded lib/mix/tasks/phx.gen.embedded.ex 6 0 5 YES 100% 0% Mix.Tasks.Phx.Gen.Html lib/mix/tasks/phx.gen.html.ex 4 0 4 YES 100% 0% Mix.Tasks.Phx.Gen.Json lib/mix/tasks/phx.gen.json.ex 4 0 4 YES 100% 0% Mix.Tasks.Phx.Gen.Presence lib/mix/tasks/phx.gen.presence.ex 1 0 1 YES 100% 14% Mix.Tasks.Phx.Gen.Schema lib/mix/tasks/phx.gen.schema.ex 7 0 6 YES 100% 0% Mix.Tasks.Phx.Gen.Secret lib/mix/tasks/phx.gen.secret.ex 1 0 1 YES 100% 0% Mix.Tasks.Phx.Routes lib/mix/tasks/phx.routes.ex 1 0 1 YES 100% 0% Mix.Tasks.Phx.Server lib/mix/tasks/phx.server.ex 1 0 1 YES 100% 0% Phoenix lib/phoenix.ex 3 0 3 YES 100% 17% Phoenix.Channel lib/phoenix/channel.ex 12 0 10 YES 100% 18% Phoenix.Channel.Server lib/phoenix/channel/server.ex 17 0 14 YES 100% 0% Phoenix.CodeReloader lib/phoenix/code_reloader.ex 2 0 2 YES 40% 0% Phoenix.CodeReloader.Proxy lib/phoenix/code_reloader/proxy.ex 5 3 5 YES 33% 0% Phoenix.CodeReloader.Server lib/phoenix/code_reloader/server.ex 6 4 6 YES 88% 25% Phoenix.Config lib/phoenix/config.ex 8 1 6 YES 100% 52% Phoenix.Controller lib/phoenix/controller.ex 42 0 20 YES 100% 0% Phoenix.Controller.Pipeline lib/phoenix/controller/pipeline.ex 6 0 6 YES 100% 100% Phoenix.Digester lib/phoenix/digester.ex 2 0 0 YES 100% 0% Phoenix.Endpoint lib/phoenix/endpoint.ex 25 0 25 YES 100% 0% Phoenix.Endpoint.Cowboy2Adapter lib/phoenix/endpoint/cowboy2_adapter.ex 3 0 3 YES 0% 0% Phoenix.Endpoint.Cowboy2Handler lib/phoenix/endpoint/cowboy2_handler.ex 5 5 5 YES 100% 0% Phoenix.Endpoint.CowboyAdapter lib/phoenix/endpoint/cowboy_adapter.ex 2 0 2 YES 0% 0% Phoenix.Endpoint.CowboyWebSocket lib/phoenix/endpoint/cowboy_websocket.ex 8 8 8 YES 100% 0% Phoenix.Endpoint.RenderErrors lib/phoenix/endpoint/render_errors.ex 3 0 3 YES 93% 0% Phoenix.Endpoint.Supervisor lib/phoenix/endpoint/supervisor.ex 15 1 15 YES 0% 0% Phoenix.Endpoint.Watcher lib/phoenix/endpoint/watcher.ex 2 2 2 YES NA NA Plug.Exception.Phoenix.ActionClauseErro lib/phoenix/exceptions.ex 0 0 0 NO NA NA Phoenix.NotAcceptableError lib/phoenix/exceptions.ex 0 0 0 YES 100% 0% Phoenix.MissingParamError lib/phoenix/exceptions.ex 1 0 1 YES 0% 0% Phoenix.ActionClauseError lib/phoenix/exceptions.ex 2 2 2 NO 60% 0% Phoenix.Logger lib/phoenix/logger.ex 5 2 5 YES 83% 100% Phoenix.Naming lib/phoenix/naming.ex 6 1 0 YES NA NA Phoenix.Param.Map lib/phoenix/param.ex 0 0 0 NO NA NA Phoenix.Param.Integer lib/phoenix/param.ex 0 0 0 NO NA NA Phoenix.Param.BitString lib/phoenix/param.ex 0 0 0 NO NA NA Phoenix.Param.Atom lib/phoenix/param.ex 0 0 0 NO NA NA Phoenix.Param.Any lib/phoenix/param.ex 0 0 0 NO 0% 0% Phoenix.Param lib/phoenix/param.ex 1 1 1 YES 100% 0% Phoenix.Presence lib/phoenix/presence.ex 17 0 17 YES NA NA Phoenix.Router.NoRouteError lib/phoenix/router.ex 0 0 0 YES 100% 0% Phoenix.Router lib/phoenix/router.ex 11 0 11 YES 100% 0% Phoenix.Router.ConsoleFormatter lib/phoenix/router/console_formatter.ex 1 0 1 YES 95% 0% Phoenix.Router.Helpers lib/phoenix/router/helpers.ex 20 1 20 YES 100% 0% Phoenix.Router.Resource lib/phoenix/router/resource.ex 1 0 1 YES 100% 20% Phoenix.Router.Route lib/phoenix/router/route.ex 5 0 4 YES 100% 0% Phoenix.Router.Scope lib/phoenix/router/scope.ex 9 0 9 YES NA NA Phoenix.Socket.InvalidMessageError lib/phoenix/socket.ex 0 0 0 YES 57% 0% Phoenix.Socket lib/phoenix/socket.ex 14 6 14 YES NA NA Phoenix.Socket.Reply lib/phoenix/socket/message.ex 0 0 0 YES 100% 0% Phoenix.Socket.Message lib/phoenix/socket/message.ex 1 0 1 YES NA NA Phoenix.Socket.Broadcast lib/phoenix/socket/message.ex 0 0 0 YES 50% 0% Phoenix.Socket.PoolSupervisor lib/phoenix/socket/pool_supervisor.ex 4 2 4 YES NA NA Phoenix.Socket.Serializer lib/phoenix/socket/serializer.ex 0 0 0 YES 0% 0% Phoenix.Socket.V1.JSONSerializer lib/phoenix/socket/serializers/v1_json_serializer.ex 3 3 3 YES 0% 0% Phoenix.Socket.V2.JSONSerializer lib/phoenix/socket/serializers/v2_json_serializer.ex 3 3 3 YES 100% 0% Phoenix.Socket.Transport lib/phoenix/socket/transport.ex 6 0 6 YES NA NA Phoenix.Template.UndefinedError lib/phoenix/template.ex 0 0 0 YES 100% 45% Phoenix.Template lib/phoenix/template.ex 11 0 6 YES 0% 0% Phoenix.Template.EExEngine lib/phoenix/template/eex_engine.ex 1 1 1 YES NA NA Phoenix.Template.Engine lib/phoenix/template/engine.ex 0 0 0 YES 0% 0% Phoenix.Template.ExsEngine lib/phoenix/template/exs_engine.ex 1 1 1 YES NA NA Phoenix.ChannelTest.NoopSerializer lib/phoenix/test/channel_test.ex 0 0 0 YES 100% 11% Phoenix.ChannelTest lib/phoenix/test/channel_test.ex 19 0 17 YES 100% 94% Phoenix.ConnTest lib/phoenix/test/conn_test.ex 17 0 1 YES 100% 0% Phoenix.Token lib/phoenix/token.ex 2 0 2 YES 67% 0% Phoenix.Transports.LongPoll lib/phoenix/transports/long_poll.ex 3 1 3 YES 50% 0% Phoenix.Transports.LongPoll.Server lib/phoenix/transports/long_poll_server.ex 4 2 4 YES 0% 0% Phoenix.Transports.WebSocket lib/phoenix/transports/websocket.ex 2 2 2 YES 100% 0% Phoenix.View lib/phoenix/view.ex 9 0 9 YES -------------------------------------------------------------------------------------------------------------------------------------------------------------------------- Summary: Passed Modules: 72 Failed Modules: 7 Total Doc Coverage: 85.1% Total Spec Coverage: 15.3% Doctor validation has passed!"}]